-- C:\WORK\HDL\CFG_TOP_5\CONFIG_WAVE.VHW
-- VHDL Test Bench created by
-- HDL Bencher 2.01
-- Wed May 29 17:49:16 2002
-- 
-- Notes:
-- 1) This testbench has been automatically generated from
--   your Test Bench Waveform
-- 2) To use this as a user modifiable testbench do the following:
--   - Save it as a file with a .vhd extension (i.e. File->Save As...)
--   - Add it to your project as a testbench source (i.e. Project->Add Source...)
-- 

LIBRARY  IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

LIBRARY ieee;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE testbench_arch OF testbench IS
-- If you get a compiler error on the following line,
-- from the menu do Options->Configuration select VHDL 87
FILE RESULTS: TEXT OPEN WRITE_MODE IS "results.txt";
	COMPONENT CONFIG
		PORT (
			CLK : in  std_logic;
			CE : in  std_logic;
			RST : in  std_logic;
			CFG_DATA : in  std_logic_vector (7 DOWNTO 0);
			CFG_RD : in  std_logic;
			READY : in  std_logic;
			DONE : in  std_logic;
			DIR : out  std_logic;
			CFG_ENB : out  std_logic;
			BUSY : out  std_logic;
			CCLK : out  std_logic;
			DIN : out  std_logic;
			PROG : out  std_logic
		);
	END COMPONENT;

	SIGNAL CLK : std_logic;
	SIGNAL CE : std_logic;
	SIGNAL RST : std_logic;
	SIGNAL CFG_DATA : std_logic_vector (7 DOWNTO 0);
	SIGNAL CFG_RD : std_logic;
	SIGNAL READY : std_logic;
	SIGNAL DONE : std_logic;
	SIGNAL DIR : std_logic;
	SIGNAL CFG_ENB : std_logic;
	SIGNAL BUSY : std_logic;
	SIGNAL CCLK : std_logic;
	SIGNAL DIN : std_logic;
	SIGNAL PROG : std_logic;

BEGIN
	UUT : CONFIG
	PORT MAP (
		CLK => CLK,
		CE => CE,
		RST => RST,
		CFG_DATA => CFG_DATA,
		CFG_RD => CFG_RD,
		READY => READY,
		DONE => DONE,
		DIR => DIR,
		CFG_ENB => CFG_ENB,
		BUSY => BUSY,
		CCLK => CCLK,
		DIN => DIN,
		PROG => PROG
	);

	PROCESS -- clock process
	BEGIN
		CLOCK_LOOP : LOOP
		CLK <= transport '0';
		WAIT FOR 1 ns;
		CLK <= transport '1';
		WAIT FOR 1 ns;
		WAIT FOR 2 ns;
		CLK <= transport '0';
		WAIT FOR 2 ns;
		END LOOP CLOCK_LOOP;
	END PROCESS;

	PROCESS
		VARIABLE TX_OUT : LINE;
		VARIABLE TX_ERROR : INTEGER := 0;

		PROCEDURE CHECK_BUSY(
			next_BUSY : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (BUSY /= next_BUSY) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns BUSY="));
				write(TX_LOC, BUSY);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_BUSY);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_CCLK(
			next_CCLK : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (CCLK /= next_CCLK) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns CCLK="));
				write(TX_LOC, CCLK);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_CCLK);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_DIN(
			next_DIN : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (DIN /= next_DIN) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns DIN="));
				write(TX_LOC, DIN);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_DIN);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_PROG(
			next_PROG : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (PROG /= next_PROG) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns PROG="));
				write(TX_LOC, PROG);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_PROG);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_CFG_ENB(
			next_CFG_ENB : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (CFG_ENB /= next_CFG_ENB) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns CFG_ENB="));
				write(TX_LOC, CFG_ENB);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_CFG_ENB);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_DIR(
			next_DIR : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (DIR /= next_DIR) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns DIR="));
				write(TX_LOC, DIR);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_DIR);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		BEGIN
		-- --------------------
		CE <= transport '0';
		RST <= transport '0';
		CFG_DATA <= transport std_logic_vector'("11111111"); --FF
		CFG_RD <= transport '1';
		READY <= transport '1';
		DONE <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=12 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=18 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=24 ns
		CE <= transport '0';
		RST <= transport '1';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=30 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=36 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=42 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=48 ns
		CE <= transport '0';
		RST <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=54 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=60 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=66 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=72 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=78 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=84 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=90 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=96 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=102 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=108 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=114 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=120 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=126 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=132 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=138 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=144 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=150 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=156 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=162 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=168 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=174 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=180 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=186 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=192 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=198 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=204 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=210 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=216 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=222 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=228 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=234 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=240 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=246 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=252 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=258 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=264 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=270 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=276 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=282 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=288 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=294 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=300 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=306 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=312 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=318 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=324 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=330 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=336 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=342 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=348 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=354 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=360 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=366 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=372 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=378 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=384 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=390 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=396 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=402 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=408 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=414 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=420 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=426 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=432 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=438 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=444 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=450 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=456 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=462 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=468 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=474 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=480 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=486 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=492 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=498 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=504 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=510 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=516 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=522 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=528 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=534 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=540 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=546 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=552 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=558 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=564 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=570 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=576 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=582 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=588 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=594 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=600 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=606 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=612 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=618 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=624 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=630 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 12 ns; -- Time=642 ns
		CE <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=648 ns
		CE <= transport '0';
		-- --------------------
		WAIT FOR 12 ns; -- Time=660 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=666 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=672 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=678 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=684 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=690 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=696 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=702 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=708 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=714 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=720 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=726 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=732 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=738 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=744 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=750 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=756 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=762 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=768 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=774 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=780 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=786 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=792 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=798 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=804 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=810 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=816 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=822 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=828 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=834 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=840 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=846 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=852 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=858 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=864 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=870 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=876 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=882 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=888 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=894 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=900 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=906 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=912 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=918 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=924 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=930 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=936 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=942 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=948 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=954 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=960 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=966 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=972 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=978 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=984 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=990 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=996 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1002 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1008 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1014 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1020 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1026 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1032 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1038 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1044 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1050 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1056 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1062 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1068 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1074 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1080 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1086 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1092 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1098 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1104 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1110 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1116 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1122 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1128 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1134 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1140 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1146 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1152 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1158 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1164 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1170 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1176 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1182 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1188 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1194 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1200 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1206 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1212 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1218 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1224 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1230 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1236 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1242 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1248 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1254 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1260 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1266 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1272 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1278 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1284 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1290 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1296 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1302 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1308 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1314 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1320 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1326 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1332 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1338 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1344 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1350 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1356 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1362 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1368 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1374 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1380 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1386 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1392 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1398 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1404 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1410 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1416 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1422 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1428 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1434 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1440 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1446 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1452 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1458 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1464 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1470 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1476 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1482 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1488 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1494 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1500 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1506 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1512 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1518 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1524 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1530 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1536 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1542 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1548 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1554 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1560 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1566 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1572 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1578 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1584 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1590 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1596 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1602 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1608 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1614 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1620 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1626 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1632 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1638 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1644 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1650 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1656 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1662 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1668 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1674 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1680 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1686 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1692 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1698 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1704 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1710 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1716 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1722 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1728 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1734 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1740 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1746 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1752 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1758 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1764 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1770 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1776 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1782 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1788 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1794 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1800 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1806 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1812 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1818 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1824 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1830 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1836 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1842 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1848 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1854 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1860 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1866 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1872 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1878 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1884 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1890 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1896 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1902 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1908 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1914 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1920 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1926 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1932 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1938 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1944 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1950 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1956 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1962 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1968 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1974 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1980 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1986 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1992 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=1998 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2004 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2010 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2016 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2022 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2028 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2034 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2040 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2046 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2052 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2058 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2064 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2070 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2076 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2082 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2088 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2094 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2100 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2106 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2112 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2118 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2124 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2130 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2136 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2142 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2148 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2154 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2160 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2166 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2172 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2178 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2184 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2190 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2196 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2202 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2208 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2214 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2220 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2226 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2232 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2238 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2244 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2250 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2256 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2262 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2268 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2274 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2280 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2286 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2292 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2298 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2304 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2310 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2316 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2322 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2328 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2334 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2340 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2346 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2352 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2358 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2364 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2370 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2376 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2382 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2388 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2394 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2400 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2406 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2412 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2418 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2424 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2430 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2436 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2442 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2448 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2454 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2460 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2466 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2472 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2478 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2484 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2490 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2496 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2502 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2508 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2514 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2520 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2526 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2532 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2538 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2544 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2550 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2556 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2562 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2568 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2574 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2580 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2586 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2592 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2598 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2604 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2610 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2616 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2622 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2628 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2634 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2640 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2646 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2652 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2658 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2664 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2670 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2676 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2682 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2688 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2694 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2700 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2706 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2712 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2718 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2724 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2730 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2736 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2742 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2748 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2754 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2760 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2766 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2772 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2778 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2784 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2790 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2796 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2802 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2808 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2814 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2820 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2826 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2832 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2838 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2844 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2850 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2856 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2862 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2868 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2874 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2880 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2886 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2892 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2898 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2904 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2910 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2916 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2922 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2928 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2934 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2940 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2946 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2952 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2958 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2964 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2970 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2976 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2982 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2988 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=2994 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3000 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3006 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3012 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3018 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3024 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3030 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3036 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3042 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3048 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3054 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3060 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3066 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3072 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3078 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3084 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3090 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3096 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3102 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3108 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3114 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3120 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3126 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3132 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3138 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3144 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3150 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3156 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3162 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3168 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3174 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3180 ns
		CFG_RD <= transport '1';
		DONE <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3186 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3192 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3198 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3204 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3210 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3216 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3222 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3228 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3234 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3240 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3246 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3252 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3258 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3264 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3270 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3276 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3282 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3288 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3294 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3300 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3306 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3312 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3318 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3324 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3330 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3336 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3342 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3348 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3354 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3360 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3366 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3372 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3378 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3384 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3390 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3396 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3402 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3408 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3414 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3420 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3426 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3432 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3438 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3444 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3450 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3456 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3462 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3468 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3474 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3480 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3486 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3492 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3498 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3504 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3510 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3516 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3522 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3528 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3534 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3540 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3546 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3552 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3558 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3564 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3570 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3576 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3582 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3588 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3594 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3600 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3606 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3612 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3618 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3624 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3630 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3636 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3642 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3648 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3654 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3660 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3666 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3672 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3678 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3684 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3690 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3696 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3702 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3708 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3714 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3720 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3726 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3732 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3738 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3744 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3750 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3756 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3762 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3768 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3774 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3780 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3786 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3792 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3798 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3804 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3810 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3816 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3822 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3828 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3834 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3840 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3846 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3852 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3858 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3864 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3870 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3876 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3882 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3888 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3894 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3900 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3906 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3912 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3918 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3924 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3930 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3936 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3942 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3948 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3954 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3960 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3966 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3972 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3978 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3984 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3990 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=3996 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4002 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4008 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4014 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4020 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4026 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4032 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4038 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4044 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4050 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4056 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4062 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4068 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4074 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4080 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4086 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4092 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4098 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4104 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4110 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4116 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4122 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4128 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4134 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4140 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4146 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4152 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4158 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4164 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4170 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4176 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4182 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4188 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4194 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4200 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4206 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4212 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4218 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4224 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4230 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4236 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4242 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4248 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4254 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4260 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4266 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4272 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4278 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4284 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4290 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4296 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4302 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4308 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4314 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4320 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4326 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4332 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4338 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4344 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4350 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4356 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4362 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4368 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4374 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4380 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4386 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4392 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4398 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4404 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4410 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4416 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4422 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4428 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4434 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4440 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4446 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4452 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4458 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4464 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4470 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4476 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4482 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4488 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4494 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4500 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4506 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4512 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4518 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4524 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4530 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4536 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4542 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4548 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4554 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4560 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4566 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4572 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4578 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4584 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4590 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4596 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4602 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4608 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4614 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4620 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4626 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4632 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4638 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4644 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4650 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4656 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4662 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4668 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4674 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4680 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4686 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4692 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4698 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4704 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4710 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4716 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4722 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4728 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4734 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4740 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4746 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4752 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4758 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4764 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4770 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4776 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4782 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4788 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4794 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4800 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4806 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4812 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4818 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4824 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4830 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4836 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4842 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4848 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4854 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4860 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4866 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4872 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4878 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4884 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4890 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4896 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4902 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4908 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4914 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4920 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4926 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4932 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4938 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4944 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4950 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4956 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4962 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4968 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4974 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4980 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4986 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4992 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=4998 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5004 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5010 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5016 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5022 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5028 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5034 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5040 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5046 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5052 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5058 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5064 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5070 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5076 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5082 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5088 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5094 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5100 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5106 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5112 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5118 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5124 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5130 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5136 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5142 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5148 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5154 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5160 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5166 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5172 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5178 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5184 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5190 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5196 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5202 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5208 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5214 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5220 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5226 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5232 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5238 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5244 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5250 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5256 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5262 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5268 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5274 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5280 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5286 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5292 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5298 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5304 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5310 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5316 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5322 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5328 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5334 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5340 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5346 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5352 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5358 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5364 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5370 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5376 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5382 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5388 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5394 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5400 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5406 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5412 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5418 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5424 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5430 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5436 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5442 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5448 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5454 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5460 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5466 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5472 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5478 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5484 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5490 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5496 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5502 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5508 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5514 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5520 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5526 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5532 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5538 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5544 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5550 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5556 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5562 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5568 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5574 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5580 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5586 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5592 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5598 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5604 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5610 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5616 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5622 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5628 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5634 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5640 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5646 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5652 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5658 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5664 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5670 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5676 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5682 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5688 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5694 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5700 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5706 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5712 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5718 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5724 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5730 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5736 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5742 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5748 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5754 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5760 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5766 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5772 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5778 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5784 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5790 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5796 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5802 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5808 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5814 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5820 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5826 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5832 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5838 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5844 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5850 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5856 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5862 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5868 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5874 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5880 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5886 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5892 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5898 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5904 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5910 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5916 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5922 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5928 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5934 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5940 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5946 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5952 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5958 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5964 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5970 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5976 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5982 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5988 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=5994 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6000 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6006 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6012 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6018 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6024 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6030 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6036 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6042 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6048 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6054 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6060 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6066 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6072 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6078 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6084 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6090 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6096 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6102 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6108 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6114 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6120 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6126 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6132 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6138 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6144 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6150 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6156 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6162 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6168 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6174 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6180 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6186 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6192 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6198 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6204 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6210 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6216 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6222 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6228 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6234 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6240 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6246 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6252 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6258 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6264 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6270 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6276 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6282 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6288 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6294 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6300 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6306 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6312 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6318 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6324 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6330 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6336 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6342 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6348 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6354 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6360 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6366 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6372 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6378 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6384 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6390 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6396 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6402 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6408 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6414 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6420 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6426 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6432 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6438 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6444 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6450 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6456 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6462 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6468 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6474 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6480 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6486 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6492 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6498 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6504 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6510 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6516 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6522 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6528 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6534 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6540 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6546 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6552 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6558 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6564 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6570 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6576 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6582 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6588 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6594 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6600 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6606 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6612 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6618 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6624 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6630 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6636 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6642 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6648 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6654 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6660 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6666 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6672 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6678 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6684 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6690 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6696 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6702 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6708 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6714 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6720 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6726 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6732 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6738 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6744 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6750 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6756 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6762 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6768 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6774 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6780 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6786 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6792 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6798 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6804 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6810 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6816 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6822 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6828 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6834 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6840 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6846 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6852 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6858 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6864 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6870 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6876 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6882 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6888 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6894 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6900 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6906 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6912 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6918 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6924 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6930 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6936 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6942 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6948 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6954 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6960 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6966 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6972 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6978 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6984 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6990 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6996 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7002 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7008 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7014 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7020 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7026 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7032 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7038 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7044 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7050 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7056 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7062 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7068 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7074 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7080 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7086 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7092 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7098 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7104 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7110 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7116 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7122 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7128 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7134 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7140 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7146 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7152 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7158 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7164 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7170 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7176 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7182 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7188 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7194 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7200 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7206 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7212 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7218 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7224 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7230 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7236 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7242 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7248 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7254 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7260 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7266 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7272 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7278 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7284 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7290 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7296 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7302 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7308 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7314 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7320 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7326 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7332 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7338 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7344 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7350 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7356 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7362 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7368 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7374 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7380 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7386 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7392 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7398 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7404 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7410 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7416 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7422 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7428 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7434 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7440 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7446 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7452 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7458 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7464 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7470 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7476 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7482 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7488 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7494 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7500 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7506 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7512 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7518 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7524 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7530 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7536 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7542 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7548 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7554 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7560 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7566 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7572 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7578 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7584 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7590 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7596 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7602 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7608 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7614 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7620 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7626 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7632 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7638 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7644 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7650 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7656 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7662 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7668 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7674 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7680 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7686 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7692 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7698 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7704 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7710 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7716 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7722 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7728 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7734 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7740 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7746 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7752 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7758 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7764 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7770 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7776 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7782 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7788 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7794 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7800 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7806 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7812 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7818 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7824 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7830 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7836 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7842 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7848 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7854 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7860 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7866 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7872 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7878 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7884 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7890 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7896 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7902 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7908 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7914 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7920 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7926 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7932 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7938 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7944 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7950 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7956 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7962 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7968 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7974 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7980 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7986 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7992 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=7998 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8004 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8010 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8016 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8022 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8028 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8034 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8040 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8046 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8052 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8058 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8064 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8070 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8076 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8082 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8088 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8094 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8100 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8106 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8112 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8118 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8124 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8130 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8136 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8142 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8148 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8154 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8160 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8166 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8172 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8178 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8184 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8190 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8196 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8202 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8208 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8214 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8220 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8226 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8232 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8238 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8244 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8250 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8256 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8262 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8268 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8274 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8280 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8286 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8292 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8298 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8304 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8310 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8316 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8322 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8328 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8334 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8340 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8346 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8352 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8358 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8364 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8370 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8376 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8382 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8388 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8394 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8400 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8406 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8412 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8418 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8424 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8430 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8436 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8442 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8448 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8454 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8460 ns
		RST <= transport '0';
		CFG_RD <= transport '1';
		DONE <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8466 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8472 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8478 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8484 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8490 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8496 ns
		CE <= transport '0';
		RST <= transport '1';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8502 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8508 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8514 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8520 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8526 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8532 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8538 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8544 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8550 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8556 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8562 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8568 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8574 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8580 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8586 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8592 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8598 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8604 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8610 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8616 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8622 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8628 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8634 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8640 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8646 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8652 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8658 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8664 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8670 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8676 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8682 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8688 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8694 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8700 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8706 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8712 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8718 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8724 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8730 ns
		CE <= transport '1';
		RST <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8736 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8742 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8748 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8754 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8760 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8766 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8772 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8778 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8784 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8790 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8796 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8802 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8808 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8814 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8820 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8826 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8832 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8838 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8844 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8850 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8856 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8862 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8868 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8874 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8880 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8886 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8892 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8898 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8904 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8910 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8916 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8922 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8928 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8934 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8940 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8946 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8952 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8958 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8964 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8970 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8976 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8982 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8988 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=8994 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9000 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9006 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9012 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9018 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9024 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9030 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9036 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9042 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9048 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9054 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9060 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9066 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9072 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9078 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9084 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9090 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9096 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9102 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9108 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9114 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9120 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9126 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9132 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9138 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9144 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9150 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9156 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9162 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9168 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9174 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9180 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9186 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9192 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9198 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9204 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9210 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9216 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9222 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9228 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9234 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9240 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9246 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9252 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9258 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9264 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9270 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9276 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9282 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9288 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9294 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9300 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9306 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9312 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9318 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9324 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9330 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9336 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9342 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9348 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9354 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9360 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9366 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9372 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9378 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9384 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9390 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9396 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9402 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9408 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9414 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9420 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9426 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9432 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9438 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9444 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9450 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9456 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9462 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9468 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9474 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9480 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9486 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9492 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9498 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9504 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9510 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9516 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9522 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9528 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9534 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9540 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9546 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9552 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9558 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9564 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9570 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9576 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9582 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9588 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9594 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9600 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9606 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9612 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9618 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9624 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9630 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9636 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9642 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9648 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9654 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9660 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9666 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9672 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9678 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9684 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9690 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9696 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9702 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9708 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9714 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9720 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9726 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9732 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9738 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9744 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9750 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9756 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9762 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9768 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9774 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9780 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9786 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9792 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9798 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9804 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9810 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9816 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9822 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9828 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9834 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9840 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9846 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9852 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9858 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9864 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9870 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9876 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9882 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9888 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9894 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9900 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9906 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9912 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9918 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9924 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9930 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9936 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9942 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9948 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9954 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9960 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9966 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9972 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9978 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9984 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9990 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=9996 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10002 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10008 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10014 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10020 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10026 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10032 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10038 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10044 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10050 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10056 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10062 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10068 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10074 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10080 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10086 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10092 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10098 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10104 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10110 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10116 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10122 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10128 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10134 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10140 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10146 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10152 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10158 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10164 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10170 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10176 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10182 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10188 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10194 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10200 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10206 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10212 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10218 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10224 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10230 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10236 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10242 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10248 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10254 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10260 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10266 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10272 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10278 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10284 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10290 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10296 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10302 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10308 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10314 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10320 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10326 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10332 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10338 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10344 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10350 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10356 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10362 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10368 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10374 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10380 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10386 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10392 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10398 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10404 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10410 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10416 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10422 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10428 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10434 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10440 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10446 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10452 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10458 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10464 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10470 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10476 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10482 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10488 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10494 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10500 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10506 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10512 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10518 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10524 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10530 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10536 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10542 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10548 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10554 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10560 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10566 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10572 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10578 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10584 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10590 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10596 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10602 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10608 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10614 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10620 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10626 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10632 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10638 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10644 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10650 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10656 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10662 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10668 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10674 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10680 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10686 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10692 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10698 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10704 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10710 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10716 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10722 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10728 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10734 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10740 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10746 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10752 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10758 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10764 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10770 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10776 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10782 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10788 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10794 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10800 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10806 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10812 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10818 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10824 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10830 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10836 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10842 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10848 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10854 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10860 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10866 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10872 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10878 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10884 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10890 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10896 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10902 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10908 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10914 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10920 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10926 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10932 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10938 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10944 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10950 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10956 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10962 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10968 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10974 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10980 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10986 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10992 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=10998 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11004 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11010 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11016 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11022 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11028 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11034 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11040 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11046 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11052 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11058 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11064 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11070 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11076 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11082 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11088 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11094 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11100 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11106 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11112 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11118 ns
		CFG_RD <= transport '0';
		DONE <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11124 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11130 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11136 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11142 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11148 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11154 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11160 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11166 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11172 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11178 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11184 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11190 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11196 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11202 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11208 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11214 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11220 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11226 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11232 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11238 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11244 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11250 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11256 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11262 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11268 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11274 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11280 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11286 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11292 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11298 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11304 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11310 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11316 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11322 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11328 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11334 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11340 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11346 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11352 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11358 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11364 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11370 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11376 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11382 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11388 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11394 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11400 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11406 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11412 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11418 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11424 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11430 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11436 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11442 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11448 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11454 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11460 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11466 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11472 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11478 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11484 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11490 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11496 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11502 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11508 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11514 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11520 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11526 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11532 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11538 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11544 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11550 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11556 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11562 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11568 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11574 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11580 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11586 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11592 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11598 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11604 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11610 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11616 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11622 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11628 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11634 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11640 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11646 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11652 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11658 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11664 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11670 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11676 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11682 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11688 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11694 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11700 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11706 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11712 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11718 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11724 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11730 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11736 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11742 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11748 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11754 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11760 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11766 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11772 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11778 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11784 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11790 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11796 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11802 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11808 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11814 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11820 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11826 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11832 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11838 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11844 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11850 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11856 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11862 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11868 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11874 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11880 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11886 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11892 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11898 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11904 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11910 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11916 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11922 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11928 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11934 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11940 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11946 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11952 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11958 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11964 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11970 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11976 ns
		CE <= transport '0';
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11982 ns
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11988 ns
		CFG_RD <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=11994 ns
		CE <= transport '1';
		CFG_RD <= transport '0';
		-- --------------------
		WAIT FOR 2340 ns; -- Time=14334 ns
		DONE <= transport '1';
		-- --------------------
		WAIT FOR 288 ns; -- Time=14622 ns
		DONE <= transport '1';
		-- --------------------
		WAIT FOR 12970 ns; -- Time=27592 ns
		-- --------------------

		IF (TX_ERROR = 0) THEN 
			write(TX_OUT,string'("No errors or warnings"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Simulation successful (not a failure).  No problems detected. "
				SEVERITY FAILURE;
		ELSE
			write(TX_OUT, TX_ERROR);
			write(TX_OUT, string'(
				" errors found in simulation"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Errors found during simulation"
				SEVERITY FAILURE;
		END IF;
	END PROCESS;
END testbench_arch;

CONFIGURATION CONFIG_cfg OF testbench IS
	FOR testbench_arch
	END FOR;
END CONFIG_cfg;
